/* eslint-disable camelcase */
const UserModel = require('../../../models/UserModel')
const { check, validationResult } = require('express-validator')
const jwt = require('jsonwebtoken')

const setUserFullNameValidationRules = () => {
  return [
    check('first_name')
      .notEmpty().withMessage('نام نمی‌تواند خالی باشد'),
    check('last_name')
      .notEmpty().withMessage('نام خانوادگی نمی‌تواند خالی باشد')
  ]
}

const setUserFullName = async (req, res, next) => {
  try {
    const { first_name, last_name } = req.body

    // اعتبارسنجی داده‌های ورودی
    const errors = validationResult(req)
    if (!errors.isEmpty()) {
      return res.status(422).json({ errors: errors.array() })
    }
    const token = req.header('Authorization').split(' ')[1]
    if (!token) return res.status(401).send('Access Denied')

    const decodedToken = jwt.verify(token, process.env.APP_SECRET)
    const user = await UserModel.findById(decodedToken.id)
    if (!user) {
      return res.status(404).json({
        error: true,
        message: 'کاربری با این شماره موبایل یافت نشد'
      })
    }

    // آپدیت نام کاربری به صورت lowercase
    user.first_name = first_name.toLowerCase()
    user.last_name = last_name.toLowerCase()
    await user.save()

    return res.json({
      message: 'نام و نام خانوادگی با موفقیت به‌روزرسانی شد'
    })
  } catch (error) {
    next(error)
  }
}

module.exports = {
  setUserFullName, setUserFullNameValidationRules
}
